From: Martin Kepplinger <martin.kepplinger@puri.sm>
Date: Mon, 27 Sep 2021 10:25:07 +0200
Subject: WIP: arm64: dts: imx8mq-librem5: describe the rear camera

---
 arch/arm64/boot/dts/freescale/imx8mq-librem5.dtsi | 43 +++++++++++++++++++++--
 1 file changed, 40 insertions(+), 3 deletions(-)

diff --git a/arch/arm64/boot/dts/freescale/imx8mq-librem5.dtsi b/arch/arm64/boot/dts/freescale/imx8mq-librem5.dtsi
index bdb3a8d..ecb845f 100644
--- a/arch/arm64/boot/dts/freescale/imx8mq-librem5.dtsi
+++ b/arch/arm64/boot/dts/freescale/imx8mq-librem5.dtsi
@@ -1366,9 +1366,29 @@ vcm@c {
 	};
 
 	/* Samsung S5K3L6XX - 13MP Rear-Facing Camera */
-	camera2@10 {
-		reg = <0x10>;
-		status = "disabled";
+	camera-rear@2d {
+		compatible = "samsung,s5k3l6xx";
+		reg = <0x2d>;
+		pinctrl-names = "default";
+		pinctrl-0 = <&pinctrl_csi2>;
+		clocks = <&clk IMX8MQ_CLK_CLKO2>;
+		clock-names = "mclk";
+		rstn-gpios = <&gpio1 26 GPIO_ACTIVE_LOW>;
+		//stdbyn-gpios = <&gpio1 0 GPIO_ACTIVE_LOW>;
+		/* analog power 2,8V */
+		vdda-supply = <&reg_vcam_2v8>;
+		/* VDDD digital power 1,2V, camera expects 0.95V..1.15V */
+		vddd-supply = <&reg_vcam_1v2>;
+		/* I/O power supply 1,8V */
+		vddio-supply = <&reg_csi_1v8>;
+		status = "okay";
+
+		port {
+			camera2_ep: endpoint {
+				data-lanes = <1 2>;
+				remote-endpoint = <&mipi2_sensor_ep>;
+			};
+		};
 	};
 
 	bat: fuel-gauge@36 {
@@ -1428,6 +1448,23 @@ mipi1_sensor_ep: endpoint {
 	};
 };
 
+&mipi_csi2 {
+	#address-cells = <1>;
+	#size-cells = <0>;
+	status = "okay";
+
+	ports {
+		port@0 {
+			reg = <0>;
+
+			mipi2_sensor_ep: endpoint {
+				remote-endpoint = <&camera2_ep>;
+				data-lanes = <1 2>;
+			};
+		};
+	};
+};
+
 &mipi_dsi {
 	#address-cells = <1>;
 	#size-cells = <0>;
